////////////////////////////////////////////////////////////
//
// SFML - Simple and Fast Multimedia Library
// Copyright (C) 2007-2009 Laurent Gomila (laurent.gom@gmail.com)
//
// This software is provided 'as-is', without any express or implied warranty.
// In no event will the authors be held liable for any damages arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it freely,
// subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented;
//    you must not claim that you wrote the original software.
//    If you use this software in a product, an acknowledgment
//    in the product documentation would be appreciated but is not required.
//
// 2. Altered source versions must be plainly marked as such,
//    and must not be misrepresented as being the original software.
//
// 3. This notice may not be removed or altered from any source distribution.
//
////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////
// Headers
////////////////////////////////////////////////////////////
#include <SFML/Window/Context.h>
#include <SFML/Window/ContextStruct.h>
#include <SFML/Internal.h>


////////////////////////////////////////////////////////////
/// Construct a new context
////////////////////////////////////////////////////////////
sfContext* sfContext_Create()
{
    return new sfContext;
}


////////////////////////////////////////////////////////////
/// Destroy an existing context
////////////////////////////////////////////////////////////
void sfContext_Destroy(sfContext* context)
{
    delete context;
}


////////////////////////////////////////////////////////////
/// Activate or deactivate a context
////////////////////////////////////////////////////////////
void sfContext_SetActive(sfContext* context, sfBool active)
{
    CSFML_CALL(context, SetActive(active == sfTrue))
}
